﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
/*
Feladat:
Egy kábelhálózat különböző csatornáin N filmet játszanak. 
Ismerjük mindegyik film kezdési és végidejét. 
Egyszerre csak 1 filmet tudunk nézni. 
Add meg, hogy maximum hány filmet nézhetünk végig és melyeket!
*/
namespace feladat
{
    class Program
    {
        //óra és perc
        struct Idő
        {
            public int o;
            public int p;
        }

        //kezdő-, végidő és eredeti sorszám
        struct Film
        {
            public Idő k;
            public Idő v;
            public int s;
        }

        static void Beolvasás(out int N, Film[] F)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Hány film adatait olvassuk be? ");
            N = Convert.ToInt32(Console.ReadLine());
            //A tömb beolvasása
            for (int i = 0; i < N; i++)
            {
                Console.Error.WriteLine("A(z) " + (i + 1) + ". film kezdő és végideje (óra perc óra perc): ");
                string óraperc = Console.ReadLine();
                string[] órapercbontva = óraperc.Split(' ');
                F[i].k.o = Convert.ToInt32(órapercbontva[0]);
                F[i].k.p = Convert.ToInt32(órapercbontva[1]);
                F[i].v.o = Convert.ToInt32(órapercbontva[2]);
                F[i].v.p = Convert.ToInt32(órapercbontva[3]);
                F[i].s = i + 1;
            }
        }

        static void Csere(ref Film egyik, ref Film másik)
        {
            Film csere = egyik;
            egyik = másik;
            másik = csere;
        }

        static void Rendezés(int n, Film[] f)
        {
            for (int i = 0; i < n - 2; i++)
            {
                int min = i;
                for (int j = i + 1; j < n; j++)
                {
                    if (f[min].v.o > f[j].v.o || (f[min].v.o == f[j].v.o && f[min].v.p > f[j].v.p))
                    {
                        min = j;
                    }
                }
                Csere(ref f[i], ref f[min]);
            }
        }

        static void Kiválogatás(int n, Film[] f, ref int db, int[] x)
        {
            Rendezés(n, f);//az f[1..n] befejezési idő szerint rendezése
            db = 0;
            x[db] = f[0].s;
            db++;
            int j = 0;
            for (int i = 1; i < n; i++)
            {
                if (f[i].k.o > f[j].v.o || (f[i].k.o == f[j].v.o && f[i].k.p > f[j].v.p))
                {
                    x[db++] = f[i].s;
                    j = i;
                }
            }
        }

        static void Kiírás(int db, int[] x)
        {
            Console.Error.Write("Megnézendő filmek száma: ");
            Console.WriteLine(db);
            Console.Error.WriteLine("Megnézendő filmek sorszámai: ");
            for (int i = 0; i < db; i++)
            {
                Console.Write(x[i]+" ");
            }
            Console.WriteLine();
        }

        static void Main(string[] args)
        {
            //Maximális elemszám
            const int MaxN = 100;
            //A tömb elemszámának deklarálása
            int N;
            //A tömb deklarálása
            Film[] f = new Film[MaxN];
            //Beolvasás
            Beolvasás(out N, f);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            int db=0;
            int[] x = new int[MaxN];
            //Megoldás
            Kiválogatás(N, f, ref db, x);
            Kiírás(db, x);
        }
    }
}
