﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
/*
Feladat:
Egy kábelhálózat különböző csatornáin N filmet játszanak. 
Ismerjük mindegyik film kezdési és végidejét. 
Egyszerre csak 1 filmet tudunk nézni. 
Add meg, hogy maximum hány filmet nézhetünk végig és melyeket!
*/
namespace feladat
{
    class Program
    {
        //óra és perc

        //kezdő-, végidő és eredeti sorszám
        struct Film
        {
            public int k;
            public int v;
            public int s;
        }

        static void Beolvasás(out int N, Film[] F)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Hány film adatait olvassuk be? ");
            N = Convert.ToInt32(Console.ReadLine());
            //A tömb beolvasása
            for (int i = 0; i < N; i++)
            {
                Console.Error.WriteLine("A(z) " + (i + 1) + ". film kezdő és végideje (óra perc óra perc): ");
                string óraperc = Console.ReadLine();
                string[] órapercbontva = óraperc.Split(' ');
                int óra;
                int perc;
                óra = Convert.ToInt32(órapercbontva[0]);
                perc = Convert.ToInt32(órapercbontva[1]);
                F[i].k = óra * 60 + perc;
                óra = Convert.ToInt32(órapercbontva[2]);
                perc = Convert.ToInt32(órapercbontva[3]);
                F[i].v = óra * 60 + perc;
                F[i].s = i + 1;
            }
        }

        static int maximum(int n, Film[] f)
        {
            int max = 0;
            for (int i = 0; i < n; i++)
            {
                if (f[i].v > max)
                {
                    max = f[i].v;
                }
            }
            return max;
        }

        static void kezdetek(int n, int m, Film[] f, int[] kezd, int[] s)
        {
            for (int i = 1; i <= m; i++)
            {
                kezd[i] = 0;
                s[i] = 0;
            }
            for (int i = 0; i < n; i++)
            {
                if (f[i].k > kezd[f[i].v])
                {
                    kezd[f[i].v] = f[i].k;
                    s[f[i].v] = i + 1;
                }
            }
        }

        static void Kiválogatás(int n, Film[] f, ref int db, int[] x)
        {
            int m = maximum(n, f); //a legutolsó végső idő (percekben)
            db = 0;
            int ido = 0;
            const int MaxM = 24 * 60;//ennyi perc van egy napon
            int[] kezd = new int[MaxM];
            int[] s = new int[MaxM];
            kezdetek(n, m, f, kezd, s);
            for (int i = 1; i <= m; i++)
            {
                if (s[i] != 0 && ido <= kezd[i])
                {
                    x[db++] = s[i];
                    ido = i;
                }
            }
        }

        static void Kiírás(int db, int[] x)
        {
            Console.Error.Write("Megnézendő filmek száma: ");
            Console.WriteLine(db);
            Console.Error.WriteLine("Megnézendő filmek sorszámai: ");
            for (int i = 0; i < db; i++)
            {
                Console.Write(x[i] + " ");
            }
            Console.WriteLine();
        }

        static void Main(string[] args)
        {
            //Maximális elemszám
            const int MaxN = 100;
            //A tömb elemszámának deklarálása
            int N;
            //A tömb deklarálása
            Film[] f = new Film[MaxN];
            //Beolvasás
            Beolvasás(out N, f);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            int db = 0;
            int[] x = new int[MaxN];
            //Megoldás
            Kiválogatás(N, f, ref db, x);
            Kiírás(db, x);
        }
    }
}
