Program Filmek_Moho_1;
(*
  Feladat:
  * Egy kábelhálózat különböző csatornáin N filmet játszanak. 
  * Ismerjük mindegyik film kezdési és végidejét. 
  * Egyszerre csak 1 filmet tudunk nézni. 
  * Add meg, hogy maximum hány filmet nézhetünk végig és melyeket!
*)
  Const
    MaxN=100;
  Type
    TIdo=Record o,p:Byte End;//óra és perc
    TFilm=Record k,v:TIdo; s:Integer End;//kezdő-, végidő és eredeti sorszám
    TFilmek=Array [1..MaxN] of TFilm;
    TIndexek=Array [1..MaxN] of Integer;
  Var
    N:Integer;
    F:TFilmek;
    Db:Integer;
    X:TIndexek;//a megnézendő filmek sorszámai

  Procedure Beolvasas(Var N:Integer; Var F:TFilmek);
    Var
      i:integer;
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatotnára írandók!
    //Például a kérdések:
    Write(StdErr,'Filmek szama (0..',MaxN,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(N);//0<=N<=MaxN
    For i:=1 to N do
    Begin
      Write(StdErr,i:3,'. film kezdo es vegideje (ora perc):'); 
      Readln(F[i].k.o,F[i].k.p,F[i].v.o,F[i].v.p); F[i].s:=i;
    End;
  End;

  Procedure Kivalogatas(Const N:Integer; Var F:TFilmek; 
                        Var Db:Integer; Var X:TIndexek);
    Var
      i,j:Integer;
      
    Procedure Rendezes(Const N:Integer; Var F:TFilmek);//az F[1..N] befejezési idő szerint rendezése
    //Minimum-kiválasztásos rendezés, de egy hatékonyabb rendezés kellene ide
    //pl. a heapsort vagy a quicksort
      Var
        i,j,min:Integer;

      Procedure Csere(Var e,f:TFilm);
        Var
          s:TFilm;
      Begin
        s:=e; e:=f; f:=s;
      End;
    
    Begin
      For i:=1 to N-1 do
      Begin
        min:=i;
	    For j:=i+1 to N do
        Begin
          If (F[min].v.o>F[j].v.o) or
             ((F[min].v.o=F[j].v.o) and (F[min].v.p>F[j].v.p)) then min:=j;
	    End;
	    Csere(F[i],F[min]);
      End;
    End;
    
  Begin//Kivalogatas
    Rendezes(N,F);//az F[1..N] befejezési idő szerint rendezése
    Db:=1; X[Db]:=F[1].s; j:=1;
    For i:=2 to N do
    Begin
      If (F[i].k.o>F[j].v.o) or 
         ((F[i].k.o=F[j].v.o) and (F[i].k.p>F[j].v.p)) then
      Begin
        Inc(Db); X[Db]:=F[i].s; j:=i;
      End;
    End;
  End;

  Procedure Kiiras(Const N:Integer; Const X:TIndexek);
    Var
      i:Integer;
  Begin
    //A kimenetet kísérő szövegek is az StdErr-re irandók!
    Write(StdErr,'A megnezendo filmek szama:'); Writeln(Db); 
    Write(StdErr,'A megnezendo filmek sorszama:'); 
    For i:=1 to Db do
    Begin
	  Write(X[i],' ');
    End;
    Writeln; 
  End;
  
Begin
  Beolvasas(N,F);
  Kivalogatas(N,F,Db,X);
  Kiiras(N,X);
End.
